//package pkgMinesweeper;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.util.*;
//import java.net.*;

public class MinesweeperBoard extends JFrame
//
{
    private static final Color myRed = new Color(250, 0,0);
    private static final Color myWhite = new Color(250, 250, 250);
    private static final Color myFlag = new Color(200, 150, 150);
 
   
    private static final Color numberColors[]  =
        {Color.blue,            //1 blue
        new Color(0, 130, 0),  //2, green
        Color.red ,             ///3 red
        new Color(50, 0, 150) , //4 green
        new Color(170, 50, 50)  }  ; //5 maroon
    
    private static final String BEGINNER = "Beginner (9x9, 10)";
    private static final String INTERMEDIATE ="Intermediate(16x16, 40)" ;
    private static final String EXPERT =  "Expert(16x30, 99)";
    
    private static final int NEWid = 0;
    private static final int BEGINNERid = 1;
    private static final int INTERMEDIATEid =2;
    private static final int EXPERTid = 3;
    
    private Color startingColor;
    
    private static   int xMax =9;
    private static   int yMax = 9;
    private static   int bombMax = 10;
    
    private MinesweeperSquare aBoard[][] ;
    //private MinesweeperSquare AnchorSquare;
    
    private sweeperLogic sweeperAPI;
    
    //private JLabel JLGenericText;
    
    private JButton  hintButton;
    private JLabel  hintStatus;
    private JLabel  flagCount;
    
    private JToggleButton  robotButton;
    
    
    private JMenuBar menuBar;
    private JMenu fileMenu ;
    private JMenuItem saveItem,     newGameItem , loadItem, AboutItem;
    
    //private JMenuItem beginnerItem,  intermediateItem , expertItem,
    private JMenuItem customItem  ;
    private int newOptionID;
    
    private JCheckBoxMenuItem checkAllowBotGuess;
    
    private JMenu networkItem;
    private JMenuItem startSeverItem, connectServerItem  ;
    
    //private JPanel BoardPanel  ;
    JPanel BoardPanel = new JPanel();
    
    private MinesweeperBoard  thisBoard;
    
    private String classPath;
    private String iconPath;
    private String userDir;
    private ImageIcon DownArrow, RightArrow , BlankIcon ;
    private boolean isApplet;
    
    
    //private int Howmany = 2;
    
    private boolean bGameOver = false;
    
    private boolean detonation = false ;
    private boolean winner;
    private boolean botIsRunning = false;
    private boolean haltBot = false;
    private boolean allowBotToGuess = false;
    
    
    private JPanel StatusPanel ;
    private Container content ;
    
    private boolean UIhasBeensetup;
    
    private sjwStrategy hintEngine;
    
    private Thread botLooper;
    
    public static void main(String arg[]){
        
        new MinesweeperBoard( false)  ;
    }
    
    
    public MinesweeperBoard( boolean isApplet   ) {
        
        
        super("sjwMinesweeper");
        thisBoard = this ;
        
        
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        
        content = getContentPane();
        
        StatusPanel = new JPanel();
        
        StatusPanel.setLayout(new BoxLayout(StatusPanel,BoxLayout.X_AXIS));
        
        
        EmptyBorder margin = new EmptyBorder(10,10,10,10);
        EtchedBorder etched = new EtchedBorder();
        CompoundBorder compound = new CompoundBorder(margin,etched);
        StatusPanel.setBorder(compound);
        
        content.add(StatusPanel,"North");
        
        robotButton = new JToggleButton("Start Bot");
        robotButton.setEnabled(false);
        
        botButtonHandler botButtonHandler = new botButtonHandler();
        robotButton.addActionListener(botButtonHandler);  //
        StatusPanel.add(robotButton);
        StatusPanel.add(Box.createHorizontalStrut(20));
        
        hintButton = new JButton("Hint!");
        hintButton.setEnabled(false);
        hintHandler hintHandler = new hintHandler();
        hintButton.addActionListener(hintHandler);
        StatusPanel.add(hintButton);
        StatusPanel.add(Box.createHorizontalStrut(20));
        
        
        hintStatus = new JLabel("Ready to play." );
        StatusPanel.add(hintStatus);
        StatusPanel.add(Box.createHorizontalStrut(20));
        StatusPanel.add(Box.createHorizontalGlue());
        
        
        StatusPanel.add(Box.createHorizontalStrut(20));
        
        flagCount = new JLabel("Found: (00/00)" );
        StatusPanel.add(flagCount);
        
        StatusPanel.add(Box.createHorizontalStrut(20));
        
        AddMinesweeperMenu();
        
        
        pack();
        this.setSize(500,500);    this.setLocation(100,100);
        
        
        setVisible(true);
        
        bGameOver = false;
        
    }
    
    private void AddMinesweeperMenu() {
        
        menuBar = new JMenuBar();
        fileMenu = new JMenu("Options");
        newGameItem = fileMenu.add("New");
        
        menuBar.add(fileMenu);
                
        newGameItem.addActionListener(new handleNewGame(NEWid)  );
        
        /*
        beginnerItem= fileMenu.add(BEGINNER);
        beginnerItem.addActionListener( new  handleNewGame(BEGINNERid) );
        
        intermediateItem =fileMenu.add(INTERMEDIATE);
        intermediateItem.addActionListener(  new  handleNewGame(INTERMEDIATEid)  );
        
        expertItem =fileMenu.add(EXPERT);
        expertItem.addActionListener( new handleNewGame(EXPERTid));
        */
        fileMenu.add(BEGINNER).addActionListener( new  handleNewGame(BEGINNERid) );
        fileMenu.add(INTERMEDIATE).addActionListener(  new  handleNewGame(INTERMEDIATEid)  );
        fileMenu.add(EXPERT).addActionListener( new handleNewGame(EXPERTid));
        
        customItem =fileMenu.add("Custom grid(X,Y, n)");
        customItem.addActionListener( new handleNewGame(4));
        customItem.setEnabled(false)  ;
      
        fileMenu.addSeparator();
        
        checkAllowBotGuess = new JCheckBoxMenuItem("Allow Bot to Guess?", false);
        checkAllowBotGuess.addActionListener(new handleAllowGuess());
        fileMenu.add(checkAllowBotGuess);
        fileMenu.addSeparator();
        
        AboutItem =fileMenu.add("About");
        AboutItem.addActionListener(new handlAboutOption());
        
         
        
        setJMenuBar(menuBar);
 
    }
    
    
    
    
    class handleNewGame implements ActionListener {
        int xMax, yMax, bombMax;
        int newOptionID;
        String optionText;
        
        public handleNewGame   (int newOptionID){
            thisBoard.newOptionID = newOptionID;
            this.newOptionID = newOptionID;
            switch (newOptionID) {
                case NEWid:
                    xMax = thisBoard.xMax;  yMax = thisBoard.yMax;  bombMax =  thisBoard.bombMax;
                    optionText =  BEGINNER;
                    break;
                case BEGINNERid:
                    xMax = 9;  yMax = 9;  bombMax = 10;
                    optionText = BEGINNER;
                    break;
                case INTERMEDIATEid:
                    xMax = 16;  yMax = 16;   bombMax = 40;
                    optionText = INTERMEDIATE;
                    break;
                case EXPERTid:
                    xMax = 30;  yMax = 16;   bombMax = 99;
                    optionText = EXPERT;
                    break;
                case 4:
                    break;
            }
            
        }
        
        public void actionPerformed(ActionEvent e){
            //(JMenuItem)e.getSource().getText     ;
           // System.out.println  ("Menu = " + ((JMenuItem)e.getSource()).getText()  );
            
           JMenuItem clicker = (JMenuItem)e.getSource();
            System.out.println  ("Menu = " +   clicker.getText()  );
            if ( newOptionID != 0 ) {
                thisBoard.setTitle("New game! " + optionText );
                thisBoard.xMax = xMax;thisBoard.yMax = yMax;thisBoard.bombMax = bombMax;
            }
            
            thisBoard.setupMap();
            
            
            //
            String flagged  = Integer.toString( sweeperAPI.getHowmanyFlagged());
            String bombs =  Integer.toString( sweeperAPI.getHowmanyBombs());
            
            if ( flagged.length() < bombs.length() ) flagged = "0"+ flagged    ;
            String flagText = "Found: (" + flagged + "/" + bombs + ")" ;
            
            flagCount.setText(flagText );
            
            hintEngine  = new sjwStrategy(sweeperAPI);
            botIsRunning = false;
            
            hintStatus.setText(  "Game has begun!");
            
        }
    }
    
    
    
    private void setupMap(){
        
        //BoardPanel.setLayout(new  GridLayout(xMax , yMax ));
        BoardPanel.setLayout(new  GridLayout(yMax ,xMax   ));
        thisBoard.content.add(BoardPanel,"Center");
        
        sweeperAPI = new sweeperLogic( xMax, yMax, bombMax);
        detonation = false;bGameOver = false;winner =false;
        hintButton.setEnabled(true);
        robotButton.setEnabled(true);
        robotButton.setSelected(false);
        robotButton.setText("Start Bot");
        botLooper = null;
        
        hintStatus.setText("");
        if (aBoard != null) {
            BoardPanel.removeAll();
        }
        
        aBoard = null;
        aBoard  =  new MinesweeperSquare[xMax ][yMax];
        
        String displayCellState = "";
        
        mouseHandlerSweeperDumb mouseHandler = new mouseHandlerSweeperDumb();
        for (int out = 0; out <= yMax -1; out++)    {
            for (int i = 0; i <= xMax -1 ; i++) {               
                aBoard[i][out] = new MinesweeperSquare( " " );
                aBoard[i][out].XSet(i);
                aBoard[i][out].YSet(out);
                if (startingColor == null) startingColor =  aBoard[i][out].getBackground(); 
                aBoard[i][out].addMouseListener(mouseHandler);
                BoardPanel.add(aBoard[i][out]);
                
            }
        }
        
        
        if (!UIhasBeensetup )  {
            pack();
            thisBoard.setSize(500,500);
        }
        setVisible(true);
        UIhasBeensetup = true;
        
    }
    
    
    private void refreshBoard() {
        int state = 0 ;
        int hint = 0;
        
        
        winner = sweeperAPI.getWinner();
        if (!botIsRunning )  {
            hintStatus.setText(  "                                 ");
        }
        
        
        for (int out = 0; out <= yMax -1; out++)    {
            
            
            for (int i = 0; i <= xMax -1 ; i++) {
                state = sweeperAPI.getState   (i, out);
                MinesweeperSquare square =  aBoard[i][out];
                if  (sweeperAPI.getIsFlagged(i,out) ) {
                    square.setBackground  (  myFlag ) ;
                } else {
                    if  (!square.getBackground().equals( startingColor ) ){
                        square.setBackground  ( startingColor );
                    }
                    hint =  sweeperAPI.getHint(i,out) ;
                    
                    switch (hint) {
                        case 0: break;
                        case 1:   square.setBackground  ( Color.green ); break;
                        case -1:  square.setBackground  ( Color.pink );break;
                        case 2:   square.setBackground  ( Color.yellow  );break;
                        default:  System.out.println("unhandled hint"); break;
                    }
                    
                }
                
                
                if (state != -2 && state != -3) {
                    if (state == -1) {
                        detonation = true;  bGameOver = true;
                        square.setBackground  ( myRed );
                        hintButton.setEnabled(false);
                        robotButton.setEnabled(false);
                        hintStatus.setText(  "Explosion!  Try again!");
                    }
                    else{
                        if (state >0)  { 
                            aBoard[i][out].setText( Integer.toString( state)) ;
                            if ( state  <= numberColors.length) square.setForeground(numberColors[state-1]);                                                        
                        }
                        if (state >=0) square.flatten();
                        
                    }
                }
                
            }
        }
        
        
        {//scoping
            
            String flagged  = Integer.toString( sweeperAPI.getHowmanyFlagged());
            String bombs =  Integer.toString( sweeperAPI.getHowmanyBombs());
            
            if ( flagged.length() < bombs.length() ) flagged = "0"+ flagged    ;
            String flagText = "Found: (" + flagged + "/" + bombs + ")" ;
            //flagCount.setText(   "(00/00)....."  );
            flagCount.setText( flagText);
        }
        
        if (winner) {
            hintStatus.setText(  "You Win!  You solved the map!");
            bGameOver = true;
        }
        
    }
    
    
    
    class mouseHandlerSweeperDumb  extends MouseInputAdapter {
        public void mousePressed(MouseEvent event) {
            
            int iMods ;
            
            if (detonation) return;
            
            iMods = event.getModifiers();
            //  System.out.println ("mods = " +  iMods + " action = " +  event.ACTION_PERFORMED + " " + event.MOUSE_EVENT_MASK );
            MinesweeperSquare bClicked = (MinesweeperSquare)event.getSource();
            int xClick = bClicked.XGet();
            int yClick = bClicked.YGet();
            
            if ((iMods  & event.BUTTON3_MASK) != 0 ) {
                sweeperAPI.setIsFlagged(xClick, yClick);
            }
            else   sweeperAPI.tap(xClick, yClick);
            
            refreshBoard();
            
        }
    }
    
    class hintHandler  implements ActionListener {
        public void actionPerformed(ActionEvent event) {
            sweeperResponse hintResponse;
            int  gotHint = 0;
            hintResponse = hintEngine.tryHint();  // sweeperAPI.tryHint();
            gotHint = hintResponse.getHintType();
            if (gotHint !=0 ) {
                refreshBoard();
                if (gotHint == -1) hintStatus.setText("  A hint for a mine!");
                if (gotHint == 1)  hintStatus.setText("  A hint for a safe square!");
                if (gotHint == 2)  hintStatus.setText("   Bot can ony guess...");
            }else hintStatus.setText("  Too hard, try guessing?");
            
        }
    }
    
    class botButtonHandler implements ActionListener {
      
        public void actionPerformed(ActionEvent event) {
           
            
            
           if (botLooper == null)  {
             botLooper = new Thread(  new botLooper(  thisBoard)  );
             botLooper.setDaemon(true);
           }
           
           if (!botIsRunning ) {           
             robotButton.setText("Pause Bot");   
             botLooper.start();
           } else{
             botIsRunning = false; haltBot= true;
           // botLooper.stop()  ;
           //  botLooper.interrupt()    ;
             robotButton.setText("Start Bot");   
             botLooper = null;
           }
                 
/*          
            sweeperResponse hintResponse;
            int  gotHint = 0;
            Color hintColor =startingColor;
            hintStatus.setText("Bot is running! ");
            
            hintResponse = hintEngine.tryHint();   //sweeperAPI.tryHint();
            gotHint = hintResponse.getHintType();
            if ( bGameOver ) return;
            
            botIsRunning = true; haltBot= false;
            
            if (gotHint == hintResponse.HINT_GUESS && !allowBotToGuess)haltBot= true;
            
            while  (gotHint != hintResponse.HINT_NONE  && !bGameOver && !haltBot) {
                
 
                
                if (gotHint  == hintResponse.HINT_SAFE)  hintColor = Color.green;
                if (gotHint  == hintResponse.HINT_BOMB)  hintColor = Color.pink;
                if (gotHint  == hintResponse.HINT_GUESS)  hintColor = Color.yellow;
                
                if (gotHint == hintResponse.HINT_GUESS) {
                    gotHint  = gotHint;
                }
                
                if (gotHint == hintResponse.HINT_BOMB ) {
                    sweeperAPI.setIsFlagged(hintResponse.getX(),  hintResponse.getY());
                }
                else {
                    aBoard[hintResponse.getX()][hintResponse.getY()].setBackground  ( hintColor );
                    thisBoard.update( (thisBoard.getGraphics() ) );
                    
                    try {
                        Thread.sleep(20);
                    }  catch (InterruptedException e) { }
                    
                    sweeperAPI.tap(hintResponse.getX(),  hintResponse.getY()  );
                }
                
                
                refreshBoard();
                thisBoard.update( (thisBoard.getGraphics() ) );
                
                
                try {
                    Thread.sleep(20);
                }  catch (InterruptedException e) { }
                
                
                if (!bGameOver) {
                    hintResponse = hintEngine.tryHint();   //sweeperAPI.tryHint();
                    gotHint = hintResponse.getHintType();
                    
                }
                if (gotHint == hintResponse.HINT_GUESS && !allowBotToGuess)haltBot= true;
            }
            botIsRunning = false;
            refreshBoard();
            robotButton.setSelected(false);
*/            
        }
    }
    
    
    class handlAboutOption implements ActionListener {
        public void actionPerformed(ActionEvent e){
            //System.out.println("About!");
            AboutSweeperBox aboutBox =new AboutSweeperBox();
        }
    }
    
    class handleAllowGuess implements ActionListener {
        public void actionPerformed(ActionEvent e){
            allowBotToGuess = !allowBotToGuess;
            
        }
    }
    
    class botLooper implements Runnable {
        MinesweeperBoard theBoard;
        public botLooper(MinesweeperBoard  sentBoard) {
            theBoard = sentBoard;
            
        }
        public void run() {
            sweeperResponse hintResponse;
            int  gotHint = 0;
            Color hintColor =startingColor;
            theBoard.hintStatus.setText("Bot is running! ");
            
            hintResponse = hintEngine.tryHint();   //sweeperAPI.tryHint();
            gotHint = hintResponse.getHintType();
            if ( bGameOver ) return;
            
            botIsRunning = true; haltBot= false;

            if (gotHint == hintResponse.HINT_GUESS && !allowBotToGuess)haltBot= true;

            while  (gotHint != hintResponse.HINT_NONE  && !bGameOver && !haltBot) {
                
 
                
                if (gotHint  == hintResponse.HINT_SAFE)  hintColor = Color.green;
                if (gotHint  == hintResponse.HINT_BOMB)  hintColor = Color.pink;
                if (gotHint  == hintResponse.HINT_GUESS)  hintColor = Color.yellow;
                
                if (gotHint == hintResponse.HINT_GUESS) {
                    gotHint  = gotHint;
                }
                
                if (gotHint == hintResponse.HINT_BOMB ) {
                    sweeperAPI.setIsFlagged(hintResponse.getX(),  hintResponse.getY());
                }
                else {
                    aBoard[hintResponse.getX()][hintResponse.getY()].setBackground  ( hintColor );
                //    thisBoard.update( (thisBoard.getGraphics() ) );
                    
                    try {
                        Thread.sleep(20);
                    }  catch (InterruptedException e) { }
                    
                    sweeperAPI.tap(hintResponse.getX(),  hintResponse.getY()  );
                }
                
                 refreshBoard();
              //      thisBoard.update( (thisBoard.getGraphics() ) );
         
                
                try {
                    Thread.sleep(20);
                }  catch (InterruptedException e) { }
                
                
                if (!bGameOver) {
                    hintResponse = hintEngine.tryHint();   //sweeperAPI.tryHint();
                    gotHint = hintResponse.getHintType();
                    
                }
                if (gotHint == hintResponse.HINT_GUESS && !allowBotToGuess)haltBot= true;
            }
  
            
            botIsRunning = false;
            refreshBoard();
            robotButton.setSelected(false);
            robotButton.setText("Start Bot");
            botLooper = null;
        }
        
    }
    
    
}
