
//package pkgMinesweeper;
import java.util.*;

public class bombMap {
    private    int xBound;
    private    int yBound;
    private static bombMap thisBombMap ;
    private sweeperCell bombArray[][];
    transient Random Draw;
    private int goodFlags;
    private boolean winner;
    private int bombCount;
    
    
    
    public bombMap(int x, int y ,int bombCount) {
        
        thisBombMap = null;
        this.bombCount = bombCount;
        setupBombMap(  x,   y ,  bombCount);
    }
    
    
    
    
    public void setHint(int x, int y, int hint)  {
        if ( x < 0 ||  y <  0 ) return;
        if ( x >=  xBound ||  y >= yBound  ) return;
        
        if (hint != 0 && hint != -1 && hint != 1 && hint !=2 ) return;
        
        bombArray[x][y].setHint(hint) ;
        
    }
    
    public int getHint(int x, int y )  {
        int answer = 0  ;
        if ( x < 0 ||  y <  0 ) return answer;
        if ( x >=  xBound ||  y >= yBound  ) return answer;
        
        answer =  bombArray[x][y].getHint();
        
        return answer;
    }
    
    
    public void setIsFlagged(int x, int y)  {
        boolean increment;
        if ( x < 0 ||  y <  0 ) return;
        
        if ( x < bombArray.length  &&  y < bombArray[0].length  )  {
            increment = !(getIsFlagged(x,y));
           
             bombArray[x][y].setIsFlagged() ;            
             if (isBomb(x,y)  && increment) goodFlags++;
             else  if (isBomb(x,y)  && !increment) goodFlags--;
            
            if  (goodFlags == bombCount ) winner = true;

        }
    }
    
    public boolean getIsFlagged(int x, int y)  {
        boolean answer = false  ;
        if ( x < 0 ||  y <  0 ) return answer;
        
        if ( x < bombArray.length  &&  y < bombArray[0].length  ) {
            answer =   bombArray[x][y].getIsFlagged();
        }
        return answer;
    }
    
     public boolean getIsFlagged(int x, int y, boolean force)  {
        boolean answer = false  ;
        answer = force;
        if ( x < 0 ||  y <  0 ) return answer;
        
        if ( x < bombArray.length  &&  y < bombArray[0].length  ) {
            answer =   bombArray[x][y].getIsFlagged();
        }
        return answer;
    }
     
    public boolean getWinner( ) {
      return   winner    ;
    }      
     
    
    public void setIsRevealed(int x, int y)  {
        if ( x < 0 ||  y <  0 ) return;
        
        if ( x < bombArray.length  &&  y < bombArray[0].length  ) {
            bombArray[x][y].setIsRevealed() ;
        }
    }
    
    
    public boolean isRevealed(int x, int y)  {
        boolean answer  =false ;
        if ( x < 0 ||  y <  0 ) return  answer;
        
        if ( x < bombArray.length  &&  y < bombArray[0].length  ) {
            answer =   bombArray[x][y].isRevealed();
        }
        return answer;
    }
    
    public int isRevealed_int(int x, int y)  {
        int answer  =0 ;
        if ( x < 0 ||  y <  0 ) return  -2;
        
        if ( x >= bombArray.length  ||  y >= bombArray[0].length  ) return -2;
        
        
        if (bombArray[x][y].isRevealed() )    answer =  -1;
        
        return answer;
    }
    
    
    public int getRandomFromLimit (int limit){
        int i = 0;
        
        if (limit <= 0) return i;
        
         i = Math.abs(Draw.nextInt()) %  limit;
         
         return i;
    }
    
    public boolean isBomb(int x, int y)  {
        boolean answer = false  ;
        
        if ( x < 0 ||  y <  0 ) return answer;
        if ( x < bombArray.length  &&  y < bombArray[0].length  ) {
            answer =   bombArray[x][y].isBomb();
        }
        return answer;
    }
    
    public int getBombNeighborCount(int x , int y) {
        int answer = 0 ;
        if ( x < bombArray.length  &&  y < bombArray[0].length  ) {
            answer =   bombArray[x][y].getBombNeighborCount()  ;
        }
        return answer;
    }
    
    private void incrementBombNeighborCount(int x, int y  ) {
        // System.out.println ("x = " + x + " y " + y);
        if (x < 0 || x > xBound -1 || y <0 || y > yBound -1) return;
        
        bombArray[x][y].incrementBombNeighborCount()   ;
    }
    
    private void setupBombMap(int x, int y ,int bombCount) {
        
        xBound = x;  yBound= y;
        goodFlags =0; winner =false;
        bombArray  = new  sweeperCell [ xBound ][ yBound];
        
        for (int i = 0;  i < xBound; i++) {
            for (int j = 0 ;  j< yBound ; j++) {
                bombArray[i][j] = new  sweeperCell();
            }
        }
        
        
        
        
        if (Draw == null )  Draw = new Random();
        
        int setBombs = 0;
        int xTest = 0; int yTest = 0;
        while (setBombs < bombCount) {
            int bombX = Math.abs(Draw.nextInt()) %  xBound;
            int bombY = Math.abs(Draw.nextInt()) %  yBound ;
            
            if (!bombArray[bombX][bombY].isBomb() ) {
                bombArray[bombX][bombY].setBomb()  ;
                //increment proximity counts of neighboring squares:
                // 4 compass points, 4 diagonals
                // done as 3 to the left, three to the right,
                // then stright up, straight down.
                incrementBombNeighborCount(bombX-1, bombY);
                incrementBombNeighborCount(bombX-1, bombY -1);
                incrementBombNeighborCount(bombX-1, bombY +1);
                incrementBombNeighborCount(bombX+1, bombY);
                incrementBombNeighborCount(bombX+1, bombY -1);
                incrementBombNeighborCount(bombX+1, bombY +1);
                incrementBombNeighborCount(bombX, bombY -1);
                incrementBombNeighborCount(bombX, bombY +1);
                
                setBombs++;
                // System.out.println (" setBombs = " +  setBombs);
            }
        }
        thisBombMap = this;
    }
    
    
    
    class sweeperCell {
        private boolean bombState;
        private boolean isRevealed;
        private boolean isFlagged = false;
        private int hint = 0;
        private int bombNeighborCount =0 ;
        
        public void incrementBombNeighborCount() {
            bombNeighborCount++;
        }
        public int getBombNeighborCount() {
            return bombNeighborCount;
        }
        public boolean isBomb() {
            return  bombState;
        }
        public void setBomb() {
            bombState = true ;
        }
        
        public boolean isRevealed() {
            return isRevealed;
        }
        public void setIsRevealed() {
            isRevealed = true;
            setIsFlagged( false);
            setHint( 0);
        }
        public void setIsFlagged() {
            isFlagged = !isFlagged;
        }
        
        public void setIsFlagged(boolean flag) {
            isFlagged = flag;
        }
        
        public boolean getIsFlagged() {
            return   isFlagged  ;
        }
        
        public void setHint(int hint ) {
            this.hint = hint;
        }
        
        public int getHint( ) {
            return   hint  ;
        }
        
       
        
    }
    
    
}


