 

public class sweeperLogic {
    private    bombMap bombs ;
    private    int xBound;
    private    int yBound;
    private    int howmanyBombs;
    private    int howmanyFlagged;
    private boolean detonation = false ;
    

    public sweeperLogic(  int x, int y ,int bombCount)   {
        
        xBound = x;  yBound= y; howmanyBombs = bombCount;
        howmanyFlagged =0;
         
        bombs = new bombMap(xBound, yBound, howmanyBombs);
    }
    
    public int getXBound() {
        return xBound;
    }
     
    
    public int getYBound() {
        return yBound;
    }
    
    public boolean getIsRevealed (int x, int y) {

       if ( x < 0 ||  y <  0 ) return false ;
       if ( x >= xBound  ||  y >=  yBound )  return false;
        
       return bombs.isRevealed(x,y) ;
    }
    
    public int getIsRevealedInt (int x, int y) {
       boolean answer;
       if ( x < 0 ||  y <  0 ) return -5 ;
       if ( x >= xBound  ||  y >=  yBound )  return -5;
       
       
       answer =bombs.isRevealed(x,y);
       if ( answer ) {
       return  -1;
       } else return 0;
        
    }
    
    
    public int getBombNeighborCount (int x, int y){
        int state =-3;
        if ( x < 0 ||  y <  0 ) return state ;
        if ( x >= xBound  ||  y >=  yBound )  return state;
        
        if  (!bombs.isRevealed(x,y)) return -2;
        
        state = bombs.getBombNeighborCount(x,y);
        return state;
        
    }
    
    
    public int getState(int x, int y ) {
        int state = -3 ;
        
        if ( x < 0 ||  y <  0 ) return state ;
        if ( x >= xBound  ||  y >=  yBound )  return state;
        
        if  (!bombs.isRevealed(x,y)) return -2;
        
        if  ( bombs.isBomb  (x,y) ) return -1;
        
        state = bombs.getBombNeighborCount(x,y);
        return state;
        
    }
    
     public void setHint(int x, int y, int hint)  {
        if ( x < 0 ||  y <  0 ) return;
        if ( x >=  xBound ||  y >= yBound  ) return;
        
        if (hint != 0 && hint != -1 && hint != 1 && hint !=2 ) return;
        
        bombs.setHint(x,y, hint) ;
        
    }
    
    public void setIsFlagged(int x, int y) {
        boolean increment;
        if ( x < 0 ||  y <  0 ) return   ;
        if ( x >= xBound  ||  y >=  yBound )  return   ;
        
        if ( bombs.isRevealed(x,y) ) return;
        
       increment = !(bombs.getIsFlagged( x,y) );
        
        bombs.setIsFlagged( x,y);
        if ( increment)  howmanyFlagged++;
        else howmanyFlagged--;
       
    }
    
    public boolean getIsFlagged(int x, int y) {
        boolean answer = false;
        if ( x < 0 ||  y <  0 ) return answer   ;
        if ( x >= xBound  ||  y >=  yBound )  return answer  ;
        answer =  bombs.getIsFlagged( x,y);
        return answer;
    }
    
     public boolean getIsFlagged(int x, int y,   boolean force) {
        boolean answer = false;
        answer = force;
        if ( x < 0 ||  y <  0 ) return answer   ;
        if ( x >= xBound  ||  y >=  yBound )  return answer  ;
        answer =  bombs.getIsFlagged( x,y);
        return answer;
    }
    
    
    public int getHowmanyFlagged() {
     return howmanyFlagged;  
    }
    
    public int getHowmanyBombs() {
     return howmanyBombs;  
    }    
    
    public boolean getWinner() {
      return bombs.getWinner();
    }   
    
    public int getRandomFromLimit(int limit) {
        return bombs.getRandomFromLimit(limit);
    }
    
    public int getHint(int x, int y) {
        int answer = 0;
        if ( x < 0 ||  y <  0 ) return answer   ;
        if ( x >= xBound  ||  y >=  yBound )  return answer  ;
        answer =  bombs.getHint( x,y);
        return answer;
    }
    
    
    public void  tap(  int x, int y  )   {
        
        if (detonation ) return;
        
        boolean isBomb = bombs.isBomb(x, y);
        
        
        if (isBomb) {
            bombs.setIsRevealed( x,y);
            detonation = true;   return;
        }
        
        int bombNeighborCount= bombs.getBombNeighborCount   (x, y);
        
        if  (bombNeighborCount == 0) {
            revealNeighbors(  x, y  ) ; return;
        }
        else bombs.setIsRevealed( x,y);
        
        
    }
    
 
    
    private void   revealNeighbors(int x, int y  ) {
        
        if (x < 0 || x > xBound -1 || y <0 || y >  yBound -1) return;
        if  ( bombs.isRevealed( x,y) ) return;
        
        
        if  ( !bombs.isBomb(x, y) && (bombs.getBombNeighborCount(x, y) > 0)){
            bombs.setIsRevealed( x,y);
            return;
        }
        
        boolean isEmpty= false;
        if  ( !bombs.isBomb(x, y) && (bombs.getBombNeighborCount(x, y) == 0)){
            isEmpty = true;
        }
        
        
        if  (isEmpty)  {
            
            bombs.setIsRevealed( x,y);
            
            revealNeighbors(x-1, y)   ;
            revealNeighbors(x+1, y)   ;
            revealNeighbors(x, y-1)   ;
            revealNeighbors(x, y+1)   ;
            
            revealNeighbors(x-1, y-1)   ;
            revealNeighbors(x-1, y+1)   ;
            revealNeighbors(x+1, y-1)   ;
            revealNeighbors(x+1, y+1)   ;
            
        }
    }
    
    
    
}
